!define SNAME "Ps+Ai Thumbs"

!include "FileFunc.nsh"
!insertmacro "GetParameters"

CRCCheck off
AutoCloseWindow True
SilentInstall silent
WindowIcon off
XPSTYLE on

Name "${SNAME}"
Icon "${SNAME}.ico"
OutFile "..\${SNAME}.exe"

LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"
VIProductVersion "0.1.0.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "(c)tpr 2008"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.1"

Var params
Var selection

Section "Main"

${GetParameters} $params

StrCmp $params "/remove" uninstall
StrCmp $params "/install" ask
StrCmp $params "/silentinstall" install

	IfFileExists "$EXEDIR\${SNAME}.ini" +3 0
	SetOutPath $EXEDIR
	File "${SNAME}.ini"

	ReadINIStr $0 "$EXEDIR\${SNAME}.ini" "Settings" "SilentInstall"
	StrCmp $0 "1" install
	
	ask:
	MessageBox MB_YESNOCANCEL "Ready to install PS+Ai Thumbs?$\n(selecting No will do uninstall)" IDYES install IDNO uninstall
	Abort
	
	install:
	
	SetOutPath "$COMMONFILES\Adobe\Shell"
	Sleep 100
	IfFileExists "$COMMONFILES\Adobe\Shell\psicon.dll" +2 0
	File psicon.dll
	IfFileExists "$COMMONFILES\Adobe\Shell\aiicon.dll" +2 0
	File aiicon.dll
	
	WriteRegStr HKEY_CLASSES_ROOT ".ai\ShellEx\{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT ".eps\ShellEx\{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT ".psd\ShellEx\{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}" "" "{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}"
	WriteRegStr HKEY_CLASSES_ROOT "Adobe.Illustrator.11\shellex\IconHandler" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT "Adobe.Illustrator.11\shellex\PropertySheetHandlers\AIPage" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT "Adobe.Illustrator.12\shellex\IconHandler" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT "Adobe.Illustrator.12\shellex\PropertySheetHandlers\AIPage" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT "Adobe.Illustrator.EPS\shellex\IconHandler" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT "Adobe.Illustrator.EPS\shellex\PropertySheetHandlers\AIPage" "" "{0C5B0CED-206B-4c39-B615-0EB23C824612}"
	WriteRegStr HKEY_CLASSES_ROOT "CLSID\{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}" "" "Photoshop Icon Handler"
	WriteRegStr HKEY_CLASSES_ROOT "CLSID\{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}\InProcServer32" "" "$COMMONFILES\Adobe\Shell\psicon.dll"
	WriteRegStr HKEY_CLASSES_ROOT "CLSID\{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}\MiscStatus" "IconBits" "16"
	WriteRegStr HKEY_CLASSES_ROOT "CLSID\{0C5B0CED-206B-4c39-B615-0EB23C824612}\InProcServer32" "" "$COMMONFILES\Adobe\Shell\AIIcon.dll"
	WriteRegStr HKEY_CLASSES_ROOT "CLSID\{0C5B0CED-206B-4c39-B615-0EB23C824612}\InProcServer32" "ThreadingModel" "Apartment"
	WriteRegStr HKEY_CLASSES_ROOT "CLSID\{0C5B0CED-206B-4c39-B615-0EB23C824612}\MiscStatus" "IconBits" "16"
	
	System::Call 'shell32::SHChangeNotify(i, i, i, i) v (0x08000000, 0, 0, 0)'
	
	Abort

uninstall:
	
	;ask if user selected Remove on install messagebox
	StrCmp $params "/remove" 0 ask_uninstall

	ReadINIStr $0 "$EXEDIR\${SNAME}.ini" "Settings" "SilentRemove"
	StrCmp $0 "1" remove
	
	ask_uninstall:
	messagebox::show MB_DEFBUTTON2|MB_TOPMOST "  Remove Ps+Ai Thumbs?" \
	"1,0" \	
	"WARNING:$\nRemoving Ps+Ai thumbs may harm installed Adobe applications." \
	"Remove it anyway" "Leave in the system"
	
	Pop $selection
	
	StrCmp $selection "1" remove
	
	Abort
	
	remove:
	
	Delete "$COMMONFILES\Adobe\Shell\psicon.dll"
	Delete "$COMMONFILES\Adobe\Shell\aiicon.dll"
		
	DeleteRegValue HKEY_CLASSES_ROOT ".ai\ShellEx\{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}" ""
	DeleteRegValue HKEY_CLASSES_ROOT ".eps\ShellEx\{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}" ""
	DeleteRegValue HKEY_CLASSES_ROOT ".psd\ShellEx\{BB2E617C-0920-11d1-9A0B-00C04FC2D6C1}" ""
	DeleteRegValue HKEY_CLASSES_ROOT "Adobe.Illustrator.11\shellex\IconHandler" ""
	DeleteRegValue HKEY_CLASSES_ROOT "Adobe.Illustrator.11\shellex\PropertySheetHandlers\AIPage" ""
	DeleteRegValue HKEY_CLASSES_ROOT "Adobe.Illustrator.12\shellex\IconHandler" ""
	DeleteRegValue HKEY_CLASSES_ROOT "Adobe.Illustrator.12\shellex\PropertySheetHandlers\AIPage" ""
	DeleteRegValue HKEY_CLASSES_ROOT "Adobe.Illustrator.EPS\shellex\IconHandler" ""
	DeleteRegValue HKEY_CLASSES_ROOT "Adobe.Illustrator.EPS\shellex\PropertySheetHandlers\AIPage" ""
	DeleteRegValue HKEY_CLASSES_ROOT "CLSID\{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}" ""
	DeleteRegValue HKEY_CLASSES_ROOT "CLSID\{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}\InProcServer32" ""
	DeleteRegValue HKEY_CLASSES_ROOT "CLSID\{0B6DC6EE-C4FD-11d1-819A-00C04FB69B4D}\MiscStatus" "IconBits"
	DeleteRegValue HKEY_CLASSES_ROOT "CLSID\{0C5B0CED-206B-4c39-B615-0EB23C824612}\InProcServer32" ""
	DeleteRegValue HKEY_CLASSES_ROOT "CLSID\{0C5B0CED-206B-4c39-B615-0EB23C824612}\InProcServer32" "ThreadingModel"
	DeleteRegValue HKEY_CLASSES_ROOT "CLSID\{0C5B0CED-206B-4c39-B615-0EB23C824612}\MiscStatus" "IconBits"
	
	RMDir "$COMMONFILES\Adobe\Shell"
	Sleep 200
	RMDir "$COMMONFILES\Adobe"
	
	System::Call 'shell32::SHChangeNotify(i, i, i, i) v (0x08000000, 0, 0, 0)'


SectionEnd